/*----------------------------------------------------------------------------.
|   CView								      |
| 									      |
|   A c68 front end and also (fanfare........)				      |
| 									      |
|   Yet another completely unexciting episode in jh's occassional	      |
|   teach yourself QPTR series. Today we trawl the bars (scrolling).	      |
| 									      |
|   This had me completely stumped for a long time. I had a app		      |
|   window, I had a part window control block, and I had random		      |
|   sized and positioned bars (or had I spent too long in one).		      |
| 									      |
|   There seemed to be something missing. Like the size of the		      |
|   entity we were scrolling and panning. I had forgotten the golden	      |
|   rule of QPTR programming						      |
| 									      |
|                 --> ALL THE WORLD'S A MENU <--			      |
| 									      |
|   Make your application window into a menu by declaring it as a	      |
|   menu window The only extra menu like bits you need to fill in	      |
|   are the nrow and ncol items. Now set up to scroll with.		      |
| 									      |
|    mw->nrow = The number of (arbitary) units the whole scroll item	      |
|               is							      |
| 									      |
|    mw->ypwcb->s[0].pos = 0 mw->ypwcb->s[0].siz = amount of scroll	      |
|               item displayed;						      |
| 									      |
|    mw->ypwcb->s[0].stt = start of scroll display; (Both in the	      |
|               same arbitary units as nrow)				      |
| 									      |
|    For example, if we had, say, a file viewer displaying a file of	      |
|    400 lines in a window that can display 20 lines at once, and we	      |
|    are at line 80 in the file, we would have:				      |
| 									      |
|    mw->nrow = 400; Total size						      |
|    mw->ypwcb->s[0].siz = 20; Viewable size				      |
|    mw->ypwcb->s[0].stt = 80; Start Position				      |
| 									      |
|   You should note the following:					      |
| 									      |
|   1. Use wm_index() in the app window draw routine			      |
| 									      |
|   2. Use wm_upbar() elsewhere. With just one x and one y section,	      |
|      this is of the form wm_upbar(wwk, mw, 0, 0);			      |
| 									      |
|   3. You must ensure that the window size is adjusted for the size	      |
|      of the scroll / pan bars when rescaling etc. When the app	      |
|      window draw routine is called (in a resize etc), you _must_	      |
|      have done this or QPTR gets mightily upset.			      |
| 									      |
|   When you've stumbled across HOW EASY this is, you wonder what	      |
|   the problem was.							      |
| 									      |
|   The thing that really annoys me about this is that once you know	      |
|   how, it's so simple. Pity it isn't explained in the			      |
|   "documentation".							      |
| 									      |
|   This example is freely abusable etc.				      |
| 									      |
| --------------------------------------------------------------------------- |
| Jonathan R Hudson Email: jrhudson@bigfoot.com                               |
| WWW: http://www.bigfoot.com/~jrhudson                       		      |
| --------------------------------------------------------------------------- |
| 									      |
`----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <qlib.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <time.h>
#include "cview.h"

long _stack = 8000;

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
long (*_conread) () = NULL;
long (*_conwrite) () = NULL;
char _prog_name[] = "cview";
char *_endmsg = NULL;

Prototype long lit_reset (struct WM_wwork *, short);

static long MMOVE (struct WM_wwork *, struct WM_litm *);
static long ACTRL (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short, short);
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long ADRAW (struct WM_wwork *, struct WM_appw *);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long APRINT (struct WM_wwork *, struct WM_litm *);
static long ASLEEP (struct WM_wwork *, struct WM_litm *);
static long MBARS (struct WM_wwork *, struct WM_litm *);

static long lit_event (struct WM_wwork *, struct WM_litm *);

static struct WM_action afun = {JSR, wm_actli, lit_event};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action actrl = {JSR, wm_ctlaw, ACTRL};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static struct WM_action aprint = {JSR, wm_actli, APRINT};
static struct WM_action asleep = {JSR, wm_actli, ASLEEP};
static struct WM_action mbars = {JSR, wm_actli, MBARS};

static WM_PWCB (1) ycb = {0};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    2		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    6		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

#define min_wid     264
#define min_hgt     86

static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
    min_wid, min_hgt, 0, 0, 12, 10,
    {
	{ 8, 0, 0, 0 },			/* infw[0] scale width */
	{ 0, 0, 4, 0 },			/* infw[1] horiz centered */
	{ 0, 0, 0, 0 },			/* info[0] unscaled */
	{ 0, 0, 0, 0 },			/* litm[0] unscaled */
	{ 0, 0, 0, 0 },			/* litm[1] unscaled */
	{ 0, 0, 0, 0 },			/* litm[2] unscaled */
	{ 0, 0, 8, 0 },			/* litm[3] right justify */
	{ 0, 0, 8, 0 },			/* litm[4] right justify */
	{ 0, 0, 0, 0 },			/* litm[5] right justify */
	{ 8, 8, 0, 0}			/* appw[0] fully scaled */
    }
};

static QD_TEXTI (END, "ESC");
                        
static struct WM_info info[ninfo + 1] =
{
    {66, 10, 6, 0, 0, 0, 2, 0, 0, NULL},
    {-1}
};

static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {438, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 7, 84,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {78, 12,			/* xsize, ysize         size */
     184, 1,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     info},			/* *pobj                pointer to object list */
    {-1}			/* end of array */
};

#define F3KEY   0xf0

extern struct WM_sprite wm_sprite_move, wm_sprite_size,
                        wm_sprite_f3, wm_sprite_sleep;

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {22, 10,   2, 2, 0, 0, 2, K_MOVE,   &wm_sprite_move,    0, &mmove},
    {22, 10,  28, 2, 0, 0, 2, K_SIZE,   &wm_sprite_size,    1, &afun},
    {22, 10,  54, 2, 0, 0, 2, K_SLEEP,  &wm_sprite_sleep,   2, &asleep},
    {22, 10, 384, 2, 0, 0, 2, F3KEY,    &wm_sprite_f3,      3, &aprint},
    {22, 10, 410, 2, 0, 0, 0, K_CANCEL, &END,               4, &aexit},
    { 2,  2,   1, 1, 0, 0, 2, K_TAB,    &mes_null,          5, &mbars},
    {-1}
};

static struct WM_menw aw0 =	/* application sub-window */
{
    434, 140,			/* xsize, ysize         size */
    2, 15,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    1, 4, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    &actrl,			/* *ctrl                control routine */
    0, 1,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    4, 2, 7,			/* psac, psbc, pssc arrow/bar clrs */
    (WM_pwcb_t *) &ycb,		/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    0, 2, 7			/* psac, psbc, pssc arrow/bar clrs */
};

static struct WM_appl appl[nappl + 1] = {(WM_appw_t *) &aw0, NULL};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat;              pointer to status area */
    (WM_wscale_t *) &wsc,	/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    438, 156,			/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    NO_WCLEAR,			/* flag                 no clear + shadow */
    1, 4, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    4, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};

static int ChanId;
static int iline;
static PLEMT pHead;
static int NLine, TopL, BotL;
static short maxline;
static short working = 0;
static short subdraw = 0;
static short update = 0;
static short llen;
static short icon = 0;
static int CVJob;
static int SubID = 0;
static short upbar = 0;
static short LimitLines = -1;

static DoText (struct WM_wwork *, int, int);
static ShowPct (struct WM_wwork *);
static void PReader (int);
static short lx = -1,ly = -1;
static short DoAct = 0;
extern char colour;
static short aink = 4;

#define XBARS 8

static void MovePtr(void)
{
    int key;
    short x, y;
    extern setptr (int, int, short *, short *, int);

    if (DoAct == 'G')
    {
	x = lx;
	y = ly;
	key = 0;
    }
    else
    {
	short tmp;
        x = aw0.xsize + XBARS/2;
        tmp = (aw0.ypwcb->s[0].siz > aw0.nrow) ? aw0.nrow : aw0.ypwcb->s[0].siz;
        y = ((int) ((aw0.ypwcb->s[0].stt + tmp / 2) * aw0.ysize)) / aw0.nrow;
        key = -1;
    }
    setptr (ChanId, -1, &x, &y, key);
    DoAct = 0;
}
/* Just in case some debugging is necessary */

static void Report (char *t)
{
    sd_setin(ChanId, -1, 7);
    io_sstrg (ChanId, -1, t, (short) strlen (t));
    sd_setin(ChanId, -1, aink);
}

/* Safe Hex */

void *xmalloc(size_t size)
{
    void *p;

    p = malloc(size);

    if(!p)
    {
        Report("Out of memory\n");
        mt_susjb(-1, -1, NULL);
    }
}

long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);	/* and re-draw */

}

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;	/* calculate event for selection key */
}

/* Refresh the application window after a hit */
/* You will be amazed by the complete lack of logic and structure here, */
/* so am I. Buts it's only a quick and dirty hack. */

Refresh (void)
{
    int i;

    if (iline > 0)
    {
	int xb;

	xb = BotL;
	if (BotL + iline >= NLine)
	{
	    iline = NLine - BotL;
	    TopL = NLine - maxline;
            if(TopL < 0)
            {
                TopL = 0;
            }
	    BotL = NLine;
	}
	else
	{
	    TopL += iline;
	    BotL += iline;
	}

	if (BotL != xb)
	{
	    aw0.ypwcb->s[0].stt = TopL;
	    wm_upbar (&ww, (struct WM_swdef *) &aw0, 0, 0);
	    if (iline > maxline)
	    {
		iline = maxline;
		sd_pos (ChanId, -1, 0, 0);
		sd_clear (ChanId, -1);
	    }
	    else
	    {
		sd_scrol (ChanId, -1, -10);
		sd_pos (ChanId, -1, 0, maxline - 1);
	    }
	    DoText (&ww, BotL - iline, BotL);
	}
    }
    else if (iline < 0 && TopL)
    {
	int xt;
	int ml;

	xt = TopL;
	if (TopL + iline <= 0)
	{
	    ml = TopL;
	    TopL = 0;
	    iline = -ml;
	    BotL = maxline;
	}
	else
	{
	    ml = TopL;
	    TopL += iline;
	    BotL += iline;
	}

	if (TopL != xt)
	{
	    aw0.ypwcb->s[0].stt = TopL;
	    wm_upbar (&ww, (struct WM_swdef *) &aw0, 0, 0);
	    iline = -iline;
	    if (iline > maxline)
	    {
		iline = maxline;
		sd_pos (ChanId, -1, 0, 0);
		sd_clear (ChanId, -1);
		DoText (&ww, TopL, BotL);
	    }
	    else
	    {
		for (i = 0; i < iline; i++)
		{
		    sd_pos (ChanId, -1, 0, 0);
		    sd_scrol (ChanId, -1, 10);
		    DoText (&ww, ml - i - 1, ml - i);
		}
	    }
	}
    }
}

/*
 * Get a pointer to a line number in the linked list of lines
 */

PLEMT GetPos (int pos)
{
    PLEMT pl;
    int i;

    for (pl = pHead, i = 0; i < pos && pl;  i++, pl = pl->next)
        ;       /* Null loop to find our line */

    return pl;
}

int DrawLine (struct QD_text *p)
{
    short nw;

    if (p->len > llen)
    {
	nw = llen;
    }
    else
    {
	nw = p->len;
    }
    io_sstrg (ChanId, -1, p->chrs, nw);
    sd_clrrt (ChanId, -1);
    io_sbyte (ChanId, -1, '\n');
}

/* 
 * Display text between top line (tl) and bottom (bl)
 */

static DoText (struct WM_wwork *wwk, int tl, int bl)
{
    int i,j;
    PLEMT sp;

    ShowPct (wwk);

    j = bl - tl;
    if(j > 0 && j <= maxline)   /* Sanity, should never happen ;-) */
    {
        sp = GetPos (tl);

        for (i = 0; (i < j) && sp ; sp = sp->next, i++)
        {   
	    DrawLine (sp->line);
        }
    }
}

/*
 * Show percentage in title bar
 */
 
ShowPct (struct WM_wwork *wwk)
{
    short pct;
    short xpixp;
    char ptxt[16];
    char *pp = ptxt;
    xpixp = info[0].xsize - 18;
    
    if(NLine)
    {
        pct = BotL * 100 / NLine;
    }
    else
    {
        pct = 100;
    }
    *pp++ = (pct/100) ? '1' : ' ';
    *pp++ = (pct % 100) / 10 + '0';
    *pp++ = (pct % 10) + '0';
    *pp++ = '%';
    *pp = 0;
    wm_swinf (wwk, (short) 1, (colour) ? 2 : 1);
    sd_pixp (wwk->chid, -1, xpixp, 0);
    sd_clrrt (wwk->chid, -1);
    io_sstrg (wwk->chid, -1, ptxt, (short) strlen(ptxt));
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    exit (0);
}

/*
 * Rethink the display. Something has moved !!!!
 */

ReThink (struct WM_wwork *wwk)
{
    int addon;

    aw0.nrow = NLine;
    maxline = aw0.ysize / 10;
    aw0.ypwcb->s[0].siz = maxline;
    addon = (NLine > maxline) ? maxline : NLine;
    BotL = TopL + addon;
    if (BotL > NLine)
    {
	BotL = NLine;
	TopL = BotL - maxline;
    }
    if(TopL < 0) TopL = 0;

    aw0.ypwcb->s[0].stt = TopL;
    DoText (wwk, TopL, BotL);
}

/* 
 * Draw action routine
 * n.b. makes room for scroll bars (8 pixels)
 */

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    int addon;

    aw0.xsize -= 8;
    wm_swdef (wwk, apw, ChanId);
    llen = aw0.xsize / 6;
    ReThink (wwk);
    wm_index (wwk, (struct WM_swdef *) apw);
    return 0;
}

/* 
 * Hit routine, calculate displacement (iline) and set a DO event
 * (From a keystroke in window event)
 * entered every second
 */

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{
    if (evnt == 1)
    {
	iline = 1;
    }
    else if (evnt == 2 || evnt == 0xd9)
    {
	iline = apw->ysize / 10 - 1;
    }
    else if (evnt == 0xd1)
    {
	iline = -apw->ysize / 10 + 1;
    }
    else if (evnt == 0xfc)
    {
	iline = -1;
    }
    else
    {
	iline = 0;
    }
    if (update)
    {

        /* Serious redisplay required */
        
	TopL = NLine;
	wwk->wstat->evnt |= PT_WAKE;
/*	update = 0; */
    }
    else if (iline)
    {
	wwk->wstat->evnt |= PT_DO;
    }
    if (upbar)
    {
	upbar = 0;
	wm_upbar (wwk, (struct WM_swdef *) apw, 0, 0);
    }
    return 50;
}

/*
 * Ctrl routine, calculate displacement (iline) and set a DO event
 * From a hit on the scroll bars.
 */

static long ACTRL (struct WM_wwork *wwk, struct WM_appw *apw,
		   struct WM_wstat *wst,
		   short bpos, short blen, short item, short evnt)
{
    int x;
    char txt[64];

    x = NLine * bpos / blen;
    iline = x - TopL;
    return PT__DO;
}

/*
 * Sleep main job to avoid conflict with output from pipe reader
 */

Slumber (void)
{
    while (subdraw)
    {
	mt_susjb (-1, 1, NULL);
    }
}

Awaken(void)
{
}

static long ASLEEP (struct WM_wwork *wwk,  struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    return PT__ZZZZ;
}

/* 
 * On the move, must redraw the window
 */

static long MMOVE (struct WM_wwork *wwk, struct WM_litm *li)
{
    short dx, dy;
    struct QLRECT rct;

    working = 1;
    Slumber ();                         /* This is probably VERY bad */
    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    aw0.xsize += 8;
    ADRAW (wwk, (struct WM_appw *) &aw0);
    Awaken();
    working = 0;
    return lit_reset (wwk, li->item);
}

static long APRINT (struct WM_wwork *wwk, struct WM_litm *li)
{
    working = 1;
    Slumber ();
    PrintView(wwk, pHead, NLine);
    Awaken();
    working = 0;
    return lit_reset (wwk, li->item);
}

static AddLine(char *txt, short res)
{
PLEMT pn = NULL;
static PLEMT pz = NULL;
char *ptr;
short nln;

    pn = xmalloc (sizeof (LEMT));
    if (pn)
    {
        /*
         * We store data in QD_text format to avoid having to
         * strlen when ever a display update is required.
         */

	nln = res + 1;
	if ((pn->line = (struct QD_text *) xmalloc (nln)) != NULL)
	{
	    pn->line->len = res - 1;
	    memcpy (pn->line->chrs, txt, pn->line->len);
	    if (pHead == NULL)
	    {
	        pHead = pn;
	    }
	    else
	    {
                if(NLine == LimitLines)
                {
                    PLEMT pl;
                    pl = pHead;
                    pHead = pHead->next;
                    free(pl->line);
                    free(pl);
                    NLine--;                    
                }
	        pz->next = pn;
	    }
	    pn->next = NULL;
	    pz = pn;
	    subdraw = 1;
	    NLine++;

            /* It would be nice to display and update NLine in the title
             * bar, but this is a bit expensive on a 68008 (and it's not
             * our window anyway, so it's a bit messy).
             */

	    if (!working && ((BotL == NLine - 1) ||
                ((NLine == LimitLines) && (BotL == NLine))))
	    {
	        if (NLine > maxline)
	        {
	    	    sd_scrol (ChanId, -1, -10);
		    sd_pos (ChanId, -1, 0, maxline - 1);
		    upbar = 1;
		}
	        TopL = NLine - maxline;
		BotL = NLine;
		if (TopL < 0)
		{
		    TopL = 0;
		}
		aw0.nrow = NLine;
		aw0.ypwcb->s[0].stt = TopL;
		DrawLine (pn->line);
	    }
	    else
	    {
	        update = 1;
	    }
	    subdraw = 0;
	}
    }
}

/*
 * This function is run as a child process. It reads lines from a pipe.
 * When the last grand-child programs terminates and closes the pipe, it
 * beeps and sleeps. 
 */

static char * AddElement(char *qt, short elem, char sep)
{
    *qt++ = '0'+ (elem / 10);
    *qt++ = '0'+ (elem % 10);
    *qt++ = sep;
    return qt;    
}

static char *Ctime(char *s, time_t *t1)
{
    struct tm *tm;
    tm = localtime(t1);
    s = AddElement(s, tm->tm_mday,'/');
    s = AddElement(s, (tm->tm_mon+1),'/');
    s = AddElement(s, tm->tm_year % 100,' ');
    s = AddElement(s, tm->tm_hour,':');
    s = AddElement(s, tm->tm_min,':');
    s = AddElement(s, tm->tm_sec,'\n');
    *s = 0;
    return s;
}
void PReader (int ipipe)
{
    char txt[512];
    int res;
    time_t t;

    t = TIME_QL_UNIX(mt_rclck());
    strcpy (txt,"CView start ");
    Ctime (txt + strlen(txt), &t);

    AddLine(txt, strlen(txt));

    while ((res = io_fline (ipipe, -1, txt, 512)) > -2)
    {
        while(working  && !icon)
        {
            mt_susjb(-1, 1, NULL);
	}                
        if(res > 0)
        {
            AddLine(txt, res);
        }
    }


    t = TIME_QL_UNIX(mt_rclck());
    strcpy (txt,"CView end  ");
    Ctime (txt + strlen(txt), &t);
    AddLine(txt, strlen(txt));
    beep(2000, 10);
/*
 * We now SUSPEND the reader, rather that let it die, because it owns
 * all the memory, and if it goes away, so does all our data. This is
 * easier than using a special (m)alloc that used the parent job id.
 */
    SubID = 0;
    
    while(1)
    {
        mt_susjb(-1, -1, NULL);
    }
}

static long MBARS (struct WM_wwork *wwk, struct WM_litm *li)
{
    short ix, inx;
    
    ix = wwk->xorg + wwk->xsize - wwk->wstat->ptpsx;
    inx = (ix >= 0 && ix < XBARS);

    if(inx)
    {
        DoAct = 'G';
    }
    else
    {
        lx = wwk->wstat->ptpsx;
        ly = wwk->wstat->ptpsy;
        DoAct = 'T';
    }
    return PT__DO;
}

main (int ac, char **av)
{
    char cmds[256], btitle[40];
    PLEMT pl, pn = NULL;
    char *ptr,*s;
    int i, ipipe;
    struct WM_wsiz *pwl;
    struct QD_text *ptitle;
    short nt;
    short icmd = 1;

    if(*av[icmd] == '-')
    {
        char *p;
    
         p = (av[icmd] + 1);
        if(*p == '\0')
        {
            if(av[++icmd])
            {
                p = av[icmd];
            }
        }
        icmd++;        
        if((LimitLines = atoi(p)) < 24)
        {
            LimitLines = -1;
        }
    }
    
    for (cmds[0] = 0, i = icmd+1; i < ac; i++)
    {
	strcat (cmds, " ");
	strcat (cmds, av[i]);
    }

    nt = strlen(av[icmd]) + 6;
    
    s = btitle;
    *s++ = '<';
    strcpy(s, av[icmd]);
    s = s + strlen(s);
    *s++ = '>';
    *s = 0;

    ptitle = (struct QD_text *)malloc(sizeof(struct QD_text) + nt);
    ptitle->len = nt;
    strcat(strcpy((char *) ptitle->chrs, av[icmd]), "      ");

    info[0].xsize = nt*6;
    info[0].pobj = (char *)ptitle;

    infw[1].xsize = info[0].xsize + 12;
    infw[1].xorg = (infw[0].xsize - infw[1].xsize)/2 + 4;
    wsc.xmin = 198 + info[0].xsize;
 
    ww.chid = getchid (0);

    if (!wm_findv (ww.chid))
    {
	exit (-1);
    }

    pwl = GetLimits(&ww);

    ChanId = io_open ("scr", 0);
    ws.wwork = &ww;		/* set cross reference */
    if(!colour)
    {
	info[0].attr.t.ink = 1; 
	aink = 7;
	sd_setin(ChanId, -1, aink);
    }

    CVJob = getpid ();

    iline = 0;
    pHead = NULL;
    NLine = 0;
    TopL = BotL = 0;

/* 
 * Prime the part window control block
 */
    aw0.ypwcb->nsec = 1;
    aw0.ypwcb->s[0].pos = 0;
    aw0.ypwcb->s[0].stt = 0;
    aw0.nrow = NLine;

    lx = (pwl->xsize - ww.xsize)/2;
    ly = (pwl->ysize - ww.ysize)/2;

    wm_prpos (&ww, lx, ly);
    wm_wdraw (&ww);

    ipipe = SpawnCmd (av[icmd], cmds);
    if (ipipe > 0)
    {
	SubID = jcall (PReader, "CView Reader", 8, 8000, 1, ipipe);
            
        /* The PICK with WAKE forces the program into the app window
         * HIT routine, which will then be called on a scheduled basis
         * (due to its +ve return value) when the pointer is in the app
         * window. This means we can poll various flags and update the
         * scroll bar as necessary.
         */

        pick (ChanId, -1, CVJob, K_WAKE);
    }
    else
    {
        char errmsg[256];

        strcpy (errmsg, "Can't run: ");
        strcat (errmsg, av[icmd]);
        strcat (errmsg, cmds);
        beep(2000, 10);
        io_sstrg(ChanId, -1, errmsg, strlen(errmsg));
    }

    while (1)
    {
	wm_rptr (&ww);

	working = 1;
	Slumber ();

	if (ws.evnt & PT_ZZZZ)
	{     
            icon = 1;
	    aw0.xsize += 8;
            Awaken();
            TopL = 99999;                /* Ensure we redraw at the bottom */
	    menu_button (&ww, btitle);
            icon = 0;
	}

	if (ws.evnt & PT_WSIZE)
	{
	    aw0.xsize += 8;
	    re_size (&ww, 1);
	}
	
	if (ws.evnt & PT_WAKE)
	{
	    aw0.xsize += 8;
	    ADRAW (&ww, (struct WM_appw *) &aw0);
	    update = 0;
	}
	
	if (ws.evnt & PT_DO)
	{
            if(DoAct)
            {
                MovePtr();
            }
            else
            {
	        Refresh ();
	    }
	}
	
        Awaken();
	working = 0;
    }
    io_close (ChanId);
    wm_cluns (&ww);
    return (0);
}
